#include <Windows.h>
#include <extcode.h>
#include <stdio.h>
#include <string.h>
#define YES 1
#define NO 0
#define TOPTREE 18000
#define TOPPATH 10000
#define TOTALSQUARES 54
#define LEFT 0
#define BACK 1
#define RIGHT 2
#define FRONT 3
#define UP 4
#define DOWN 5
#define LEFTCW 0
#define BACKCW 2
#define RIGHTCW 4
#define FRONTCW 6
#define UPCW 8
#define DOWNCW 10
#define GREEN 0
#define RED 1
#define BLUE 2
#define WHITE 3
#define YELLOW 4
#define ORANGE 5

void move(int movement);
void calculateFinalNode();
void checkSuperiorCrux();
void checkSuperiorCorner();
void checkMiddle();
void checkInferiorCrux();
void checkInferiorCorner();
void checkLast();
tempSide[6];
int temp;
tFront = FRONT;
void temporalFront(int face)
{
	if (face == FRONT)
	{
		tempSide[LEFT] = LEFTCW;
		tempSide[BACK] = BACKCW;
		tempSide[RIGHT] = RIGHTCW;
		tempSide[FRONT] = FRONTCW;
		tempSide[UP] = UPCW;
		tempSide[DOWN] = DOWNCW;
	}
	if (face == LEFT)
	{
		tempSide[LEFT] = BACKCW;
		tempSide[BACK] = RIGHTCW;
		tempSide[RIGHT] = FRONTCW;
		tempSide[FRONT] = LEFTCW;
		tempSide[UP] = UPCW;
		tempSide[DOWN] = DOWNCW;
	}
	if (face == BACK)
	{
		tempSide[FRONT] = BACKCW;
		tempSide[LEFT] = RIGHTCW;
		tempSide[BACK] = FRONTCW;
		tempSide[RIGHT] = LEFTCW;
		tempSide[UP] = UPCW;
		tempSide[DOWN] = DOWNCW;
	}
	if (face == RIGHT)
	{
		tempSide[FRONT] = RIGHTCW;
		tempSide[LEFT] = FRONTCW;
		tempSide[BACK] = LEFTCW;
		tempSide[RIGHT] = BACKCW;
		tempSide[UP] = UPCW;
		tempSide[DOWN] = DOWNCW;
	}
}
typedef struct
{
	int L[9];
	int R[9];
	int F[9];
	int B[9];
	int U[9];
	int D[9];
}cubeFaces;

int position;
cubeFaces faces;
cubeFaces startNode;
cubeFaces tempNode;
int paths[2] = { 0, 0 };
int finished = NO;
typedef struct {
	int path[TOPPATH];
	int nodes;
	cubeFaces actualNode;
}list;
list N[TOPPATH];
cubeFaces finalNode;
int step = 0;
int finalPath[2];
int firstdone = NO;
int firstComplete[9];
int firstPath;

int sameArray(int *first, int *second, int length)
{
	int same = YES;
	for (int tsi = 0; tsi < length; tsi++)
	{
		if (*(first + tsi) != *(second + tsi))
			same = NO;
	}
	return same;
}



int32_t __declspec(dllexport) 
rubik(int32_t *left, int32_t *right, int32_t *front, int32_t *back, int32_t *up, int32_t *down, int32_t send, int32_t iteration)
{
	

	

	if (send != 0)
	{
		while (firstdone == NO)
		{
			for (int i = 0; i < 9; i++)
			{
				startNode.B[i] = *(back + i);
				startNode.R[i] = *(right + i);
				startNode.F[i] = *(front + i);
				startNode.L[i] = *(left + i);
				startNode.U[i] = *(up + i);
				startNode.D[i] = *(down + i);
				firstComplete[i] = *(up + 4);
			}
			N[0].nodes = 1;
			
			calculateFinalNode();
			N[0].actualNode = startNode;

			checkSuperiorCrux();
			checkSuperiorCorner();
			checkMiddle();
			checkInferiorCrux();
			checkInferiorCorner();
			checkLast();

			N[0].path[0] = N[0].nodes;
			
		
			firstdone = YES;

		}
		
		
	}
	if (send == NO)
		firstdone = NO;

	return N[0].path[iteration];



}





/*
0 ->left CW
1 ->left CCW
2 ->back CW
3 ->back CCW
4 ->right CW
5 ->right CCW
6 ->front CW
7 ->front CCW
*/

void move(int movement)
{
	int temp[9];
	int temp2[12];
	if (movement == 0)
	{
		for (int i = 0; i < 9; i++)
		{
			temp[i] = tempNode.L[i];
		}
		tempNode.L[0] = temp[6];
		tempNode.L[1] = temp[3];
		tempNode.L[2] = temp[0];
		tempNode.L[3] = temp[7];
		tempNode.L[5] = temp[1];
		tempNode.L[6] = temp[8];
		tempNode.L[7] = temp[5];
		tempNode.L[8] = temp[2];

		for (int i = 0; i < 12; i++)
		{
			if (i < 3)
			{
				temp2[i] = tempNode.U[i * 3];
			}
			if (i >= 3 && i < 6)
			{
				temp2[i] = tempNode.F[(i - 3) * 3];
			}
			if (i >= 6 && i < 9)
			{
				temp2[i] = tempNode.D[(i - 6) * 3];
			}
			if (i >= 9)
			{
				temp2[i] = tempNode.B[(i - 9) * 3 + 2];
			}

		}
		tempNode.U[0] = temp2[11];
		tempNode.U[3] = temp2[10];
		tempNode.U[6] = temp2[9];
		tempNode.F[0] = temp2[0];
		tempNode.F[3] = temp2[1];
		tempNode.F[6] = temp2[2];
		tempNode.D[0] = temp2[3];
		tempNode.D[3] = temp2[4];
		tempNode.D[6] = temp2[5];
		tempNode.B[2] = temp2[8];
		tempNode.B[5] = temp2[7];
		tempNode.B[8] = temp2[6];

	}

	if (movement == 1)
	{
		for (int i = 0; i < 9; i++)
		{
			temp[i] = tempNode.L[i];
		}
		tempNode.L[0] = temp[2];
		tempNode.L[1] = temp[5];
		tempNode.L[2] = temp[8];
		tempNode.L[3] = temp[1];
		tempNode.L[5] = temp[7];
		tempNode.L[6] = temp[0];
		tempNode.L[7] = temp[3];
		tempNode.L[8] = temp[6];

		for (int i = 0; i < 12; i++)
		{
			if (i < 3)
			{
				temp2[i] = tempNode.U[i * 3];
			}
			if (i >= 3 && i < 6)
			{
				temp2[i] = tempNode.F[(i - 3) * 3];
			}
			if (i >= 6 && i < 9)
			{
				temp2[i] = tempNode.D[(i - 6) * 3];
			}
			if (i >= 9)
			{
				temp2[i] = tempNode.B[(i - 9) * 3 + 2];
			}

		}
		tempNode.U[0] = temp2[3];
		tempNode.U[3] = temp2[4];
		tempNode.U[6] = temp2[5];
		tempNode.F[0] = temp2[6];
		tempNode.F[3] = temp2[7];
		tempNode.F[6] = temp2[8];
		tempNode.D[0] = temp2[11];
		tempNode.D[3] = temp2[10];
		tempNode.D[6] = temp2[9];
		tempNode.B[2] = temp2[2];
		tempNode.B[5] = temp2[1];
		tempNode.B[8] = temp2[0];

	}

	if (movement == 2)
	{
		for (int i = 0; i < 9; i++)
		{
			temp[i] = tempNode.B[i];
		}
		tempNode.B[0] = temp[6];
		tempNode.B[1] = temp[3];
		tempNode.B[2] = temp[0];
		tempNode.B[3] = temp[7];
		tempNode.B[5] = temp[1];
		tempNode.B[6] = temp[8];
		tempNode.B[7] = temp[5];
		tempNode.B[8] = temp[2];

		for (int i = 0; i < 12; i++)
		{
			if (i < 3)
			{
				temp2[i] = tempNode.U[i]; //tempNode.U[0, 1, 2] temp2[0, 1, 2]
			}
			if (i >= 3 && i < 6)
			{
				temp2[i] = tempNode.L[(i - 3) * 3]; //tempNode.L[0, 3, 6] temp2[3, 4, 5]
			}
			if (i >= 6 && i < 9)
			{
				temp2[i] = tempNode.D[(i)]; //tempNode.D[6, 7, 8] temp2[6, 7, 8]
			}
			if (i >= 9)
			{
				temp2[i] = tempNode.R[(i - 9) * 3 + 2]; //tempNode.R[2, 5, 8] temp2[9, 10, 11]
			}

		}
		tempNode.U[0] = temp2[9];
		tempNode.U[1] = temp2[10];
		tempNode.U[2] = temp2[11];
		tempNode.L[0] = temp2[2];
		tempNode.L[3] = temp2[1];
		tempNode.L[6] = temp2[0];
		tempNode.D[6] = temp2[3];
		tempNode.D[7] = temp2[4];
		tempNode.D[8] = temp2[5];
		tempNode.R[2] = temp2[8];
		tempNode.R[5] = temp2[7];
		tempNode.R[8] = temp2[6];

	}

	if (movement == 3)
	{
		for (int i = 0; i < 9; i++)
		{
			temp[i] = tempNode.B[i];
		}
		tempNode.B[0] = temp[2];
		tempNode.B[1] = temp[5];
		tempNode.B[2] = temp[8];
		tempNode.B[3] = temp[1];
		tempNode.B[5] = temp[7];
		tempNode.B[6] = temp[0];
		tempNode.B[7] = temp[3];
		tempNode.B[8] = temp[6];

		for (int i = 0; i < 12; i++)
		{
			if (i < 3)
			{
				temp2[i] = tempNode.U[i]; //tempNode.U[0, 1, 2] temp2[0, 1, 2]
			}
			if (i >= 3 && i < 6)
			{
				temp2[i] = tempNode.L[(i - 3) * 3]; //tempNode.L[0, 3, 6] temp2[3, 4, 5]
			}
			if (i >= 6 && i < 9)
			{
				temp2[i] = tempNode.D[(i)]; //tempNode.D[6, 7, 8] temp2[6, 7, 8]
			}
			if (i >= 9)
			{
				temp2[i] = tempNode.R[(i - 9) * 3 + 2]; //tempNode.R[2, 5, 8] temp2[9, 10, 11]
			}

		}
		tempNode.U[0] = temp2[5];
		tempNode.U[1] = temp2[4];
		tempNode.U[2] = temp2[3];
		tempNode.L[0] = temp2[6];
		tempNode.L[3] = temp2[7];
		tempNode.L[6] = temp2[8];
		tempNode.D[6] = temp2[11];
		tempNode.D[7] = temp2[10];
		tempNode.D[8] = temp2[9];
		tempNode.R[2] = temp2[0];
		tempNode.R[5] = temp2[1];
		tempNode.R[8] = temp2[2];

	}

	if (movement == 4)
	{
		for (int i = 0; i < 9; i++)
		{
			temp[i] = tempNode.R[i];
		}
		tempNode.R[0] = temp[6];
		tempNode.R[1] = temp[3];
		tempNode.R[2] = temp[0];
		tempNode.R[3] = temp[7];
		tempNode.R[5] = temp[1];
		tempNode.R[6] = temp[8];
		tempNode.R[7] = temp[5];
		tempNode.R[8] = temp[2];

		for (int i = 0; i < 12; i++)
		{
			if (i < 3)
			{
				temp2[i] = tempNode.U[(i * 3) + 2]; //tempNode.U[2 5 7] temp2[0 1 2]
			}
			if (i >= 3 && i < 6)
			{
				temp2[i] = tempNode.F[(i - 3) * 3 + 2]; //tempNode.F[2 5 7] temp2[3 4 5]
			}
			if (i >= 6 && i < 9)
			{
				temp2[i] = tempNode.D[(i - 6) * 3 + 2]; //tempNode.D[2 5 7] temp2 [6 7 8]
			}
			if (i >= 9)
			{
				temp2[i] = tempNode.B[(i - 9) * 3]; //tempNode.B[0 3 6] temp2[9 10 11]
			}

		}
		tempNode.U[2] = temp2[3];
		tempNode.U[5] = temp2[4];
		tempNode.U[8] = temp2[5];
		tempNode.F[2] = temp2[6];
		tempNode.F[5] = temp2[7];
		tempNode.F[8] = temp2[8];
		tempNode.D[2] = temp2[11];
		tempNode.D[5] = temp2[10];
		tempNode.D[8] = temp2[9];
		tempNode.B[0] = temp2[2];
		tempNode.B[3] = temp2[1];
		tempNode.B[6] = temp2[0];

	}

	if (movement == 5)
	{
		for (int i = 0; i < 9; i++)
		{
			temp[i] = tempNode.R[i];
		}
		tempNode.R[0] = temp[2];
		tempNode.R[1] = temp[5];
		tempNode.R[2] = temp[8];
		tempNode.R[3] = temp[1];
		tempNode.R[5] = temp[7];
		tempNode.R[6] = temp[0];
		tempNode.R[7] = temp[3];
		tempNode.R[8] = temp[6];

		for (int i = 0; i < 12; i++)
		{
			if (i < 3)
			{
				temp2[i] = tempNode.U[(i * 3) + 2]; //tempNode.U[2 5 7] temp2[0 1 2]
			}
			if (i >= 3 && i < 6)
			{
				temp2[i] = tempNode.F[(i - 3) * 3 + 2]; //tempNode.F[2 5 7] temp2[3 4 5]
			}
			if (i >= 6 && i < 9)
			{
				temp2[i] = tempNode.D[(i - 6) * 3 + 2]; //tempNode.D[2 5 7] temp2 [6 7 8]
			}
			if (i >= 9)
			{
				temp2[i] = tempNode.B[(i - 9) * 3]; //tempNode.B[0 3 6] temp2[9 10 11]
			}

		}
		tempNode.U[2] = temp2[11];
		tempNode.U[5] = temp2[10];
		tempNode.U[8] = temp2[9];
		tempNode.F[2] = temp2[0];
		tempNode.F[5] = temp2[1];
		tempNode.F[8] = temp2[2];
		tempNode.D[2] = temp2[3];
		tempNode.D[5] = temp2[4];
		tempNode.D[8] = temp2[5];
		tempNode.B[0] = temp2[8];
		tempNode.B[3] = temp2[7];
		tempNode.B[6] = temp2[6];

	}

	if (movement == 6)
	{
		for (int i = 0; i < 9; i++)
		{
			temp[i] = tempNode.F[i];
		}
		tempNode.F[0] = temp[6];
		tempNode.F[1] = temp[3];
		tempNode.F[2] = temp[0];
		tempNode.F[3] = temp[7];
		tempNode.F[5] = temp[1];
		tempNode.F[6] = temp[8];
		tempNode.F[7] = temp[5];
		tempNode.F[8] = temp[2];

		for (int i = 0; i < 12; i++)
		{
			if (i < 3)
			{
				temp2[i] = tempNode.U[(i + 6)]; //tempNode.U[6, 7, 8] temp2[0, 1, 2]
			}
			if (i >= 3 && i < 6)
			{
				temp2[i] = tempNode.L[(i - 3) * 3 + 2]; //tempNode.L[2, 5, 8] temp2[3, 4, 5]
			}
			if (i >= 6 && i < 9)
			{
				temp2[i] = tempNode.D[i - 6]; //tempNode.D[0, 1, 2] temp2[6, 7, 8]
			}
			if (i >= 9)
			{
				temp2[i] = tempNode.R[(i - 9) * 3]; //tempNode.R[0, 3, 6] temp2[9, 10, 11]
			}

		}
		tempNode.U[6] = temp2[5];
		tempNode.U[7] = temp2[4];
		tempNode.U[8] = temp2[3];
		tempNode.L[2] = temp2[6];
		tempNode.L[5] = temp2[7];
		tempNode.L[8] = temp2[8];
		tempNode.D[0] = temp2[11];
		tempNode.D[1] = temp2[10];
		tempNode.D[2] = temp2[9];
		tempNode.R[0] = temp2[0];
		tempNode.R[3] = temp2[1];
		tempNode.R[6] = temp2[2];

	}

	if (movement == 7)
	{
		for (int i = 0; i < 9; i++)
		{
			temp[i] = tempNode.F[i];
		}
		tempNode.F[0] = temp[2];
		tempNode.F[1] = temp[5];
		tempNode.F[2] = temp[8];
		tempNode.F[3] = temp[1];
		tempNode.F[5] = temp[7];
		tempNode.F[6] = temp[0];
		tempNode.F[7] = temp[3];
		tempNode.F[8] = temp[6];

		for (int i = 0; i < 12; i++)
		{
			if (i < 3)
			{
				temp2[i] = tempNode.U[(i + 6)]; //tempNode.U[6, 7, 8] temp2[0, 1, 2]
			}
			if (i >= 3 && i < 6)
			{
				temp2[i] = tempNode.L[(i - 3) * 3 + 2]; //tempNode.L[2, 5, 8] temp2[3, 4, 5]
			}
			if (i >= 6 && i < 9)
			{
				temp2[i] = tempNode.D[i - 6]; //tempNode.D[0, 1, 2] temp2[6, 7, 8]
			}
			if (i >= 9)
			{
				temp2[i] = tempNode.R[(i - 9) * 3]; //tempNode.R[0, 3, 6] temp2[9, 10, 11]
			}

		}
		tempNode.U[6] = temp2[9];
		tempNode.U[7] = temp2[10];
		tempNode.U[8] = temp2[11];
		tempNode.L[2] = temp2[2];
		tempNode.L[5] = temp2[1];
		tempNode.L[8] = temp2[0];
		tempNode.D[0] = temp2[3];
		tempNode.D[1] = temp2[4];
		tempNode.D[2] = temp2[5];
		tempNode.R[0] = temp2[8];
		tempNode.R[3] = temp2[7];
		tempNode.R[6] = temp2[6];

	}

	if (movement == 8)
	{
		for (int i = 0; i < 9; i++)
		{
			temp[i] = tempNode.U[i];
		}
		tempNode.U[0] = temp[6];
		tempNode.U[1] = temp[3];
		tempNode.U[2] = temp[0];
		tempNode.U[3] = temp[7];
		tempNode.U[5] = temp[1];
		tempNode.U[6] = temp[8];
		tempNode.U[7] = temp[5];
		tempNode.U[8] = temp[2];

		for (int i = 0; i < 12; i++)
		{
			if (i < 3)
			{
				temp2[i] = tempNode.F[(i)]; //tempNode.F[0, 1, 2] temp2[0, 1, 2]
			}
			if (i >= 3 && i < 6)
			{
				temp2[i] = tempNode.R[(i - 3)]; //tempNode.R[0, 1, 2] temp2[3, 4, 5]
			}
			if (i >= 6 && i < 9)
			{
				temp2[i] = tempNode.B[i - 6]; //tempNode.B[0, 1, 2] temp2[6, 7, 8]
			}
			if (i >= 9)
			{
				temp2[i] = tempNode.L[(i - 9)]; //tempNode.L[0, 1, 2] temp2[9, 10, 11]
			}

		}
		tempNode.F[0] = temp2[3];
		tempNode.F[1] = temp2[4];
		tempNode.F[2] = temp2[5];
		tempNode.L[0] = temp2[0];
		tempNode.L[1] = temp2[1];
		tempNode.L[2] = temp2[2];
		tempNode.B[0] = temp2[9];
		tempNode.B[1] = temp2[10];
		tempNode.B[2] = temp2[11];
		tempNode.R[0] = temp2[6];
		tempNode.R[1] = temp2[7];
		tempNode.R[2] = temp2[8];

	}

	if (movement == 9)
	{
		for (int i = 0; i < 9; i++)
		{
			temp[i] = tempNode.U[i];
		}
		tempNode.U[0] = temp[2];
		tempNode.U[1] = temp[5];
		tempNode.U[2] = temp[8];
		tempNode.U[3] = temp[1];
		tempNode.U[5] = temp[7];
		tempNode.U[6] = temp[0];
		tempNode.U[7] = temp[3];
		tempNode.U[8] = temp[6];

		for (int i = 0; i < 12; i++)
		{
			if (i < 3)
			{
				temp2[i] = tempNode.F[(i)]; //tempNode.F[0, 1, 2] temp2[0, 1, 2]
			}
			if (i >= 3 && i < 6)
			{
				temp2[i] = tempNode.R[(i - 3)]; //tempNode.R[0, 1, 2] temp2[3, 4, 5]
			}
			if (i >= 6 && i < 9)
			{
				temp2[i] = tempNode.B[i - 6]; //tempNode.B[0, 1, 2] temp2[6, 7, 8]
			}
			if (i >= 9)
			{
				temp2[i] = tempNode.L[(i - 9)]; //tempNode.L[0, 1, 2] temp2[9, 10, 11]
			}

		}
		tempNode.F[0] = temp2[9];
		tempNode.F[1] = temp2[10];
		tempNode.F[2] = temp2[11];
		tempNode.L[0] = temp2[6];
		tempNode.L[1] = temp2[7];
		tempNode.L[2] = temp2[8];
		tempNode.B[0] = temp2[3];
		tempNode.B[1] = temp2[4];
		tempNode.B[2] = temp2[5];
		tempNode.R[0] = temp2[0];
		tempNode.R[1] = temp2[1];
		tempNode.R[2] = temp2[2];

	}

	if (movement == 10)
	{
		for (int i = 0; i < 9; i++)
		{
			temp[i] = tempNode.D[i];
		}
		tempNode.D[0] = temp[6];
		tempNode.D[1] = temp[3];
		tempNode.D[2] = temp[0];
		tempNode.D[3] = temp[7];
		tempNode.D[5] = temp[1];
		tempNode.D[6] = temp[8];
		tempNode.D[7] = temp[5];
		tempNode.D[8] = temp[2];

		for (int i = 0; i < 12; i++)
		{
			if (i < 3)
			{
				temp2[i] = tempNode.F[(i + 6)]; //tempNode.F[6, 7, 8] temp2[0, 1, 2]
			}
			if (i >= 3 && i < 6)
			{
				temp2[i] = tempNode.R[(i + 3)]; //tempNode.R[6, 7, 8] temp2[3, 4, 5]
			}
			if (i >= 6 && i < 9)
			{
				temp2[i] = tempNode.B[i]; //tempNode.B[6, 7, 8] temp2[6, 7, 8]
			}
			if (i >= 9)
			{
				temp2[i] = tempNode.L[(i - 3)]; //tempNode.L[6, 7, 8] temp2[9, 10, 11]
			}

		}
		tempNode.F[6] = temp2[9];
		tempNode.F[7] = temp2[10];
		tempNode.F[8] = temp2[11];
		tempNode.L[6] = temp2[6];
		tempNode.L[7] = temp2[7];
		tempNode.L[8] = temp2[8];
		tempNode.B[6] = temp2[3];
		tempNode.B[7] = temp2[4];
		tempNode.B[8] = temp2[5];
		tempNode.R[6] = temp2[0];
		tempNode.R[7] = temp2[1];
		tempNode.R[8] = temp2[2];

	}

	if (movement == 11)
	{
		for (int i = 0; i < 9; i++)
		{
			temp[i] = tempNode.D[i];
		}
		tempNode.D[0] = temp[2];
		tempNode.D[1] = temp[5];
		tempNode.D[2] = temp[8];
		tempNode.D[3] = temp[1];
		tempNode.D[5] = temp[7];
		tempNode.D[6] = temp[0];
		tempNode.D[7] = temp[3];
		tempNode.D[8] = temp[6];

		for (int i = 0; i < 12; i++)
		{
			if (i < 3)
			{
				temp2[i] = tempNode.F[(i + 6)]; //tempNode.F[6, 7, 8] temp2[0, 1, 2]
			}
			if (i >= 3 && i < 6)
			{
				temp2[i] = tempNode.R[(i + 3)]; //tempNode.R[6, 7, 8] temp2[3, 4, 5]
			}
			if (i >= 6 && i < 9)
			{
				temp2[i] = tempNode.B[i]; //tempNode.B[6, 7, 8] temp2[6, 7, 8]
			}
			if (i >= 9)
			{
				temp2[i] = tempNode.L[(i - 3)]; //tempNode.L[6, 7, 8] temp2[9, 10, 11]
			}

		}
		tempNode.F[6] = temp2[3];
		tempNode.F[7] = temp2[4];
		tempNode.F[8] = temp2[5];
		tempNode.L[6] = temp2[0];
		tempNode.L[7] = temp2[1];
		tempNode.L[8] = temp2[2];
		tempNode.B[6] = temp2[9];
		tempNode.B[7] = temp2[10];
		tempNode.B[8] = temp2[11];
		tempNode.R[6] = temp2[6];
		tempNode.R[7] = temp2[7];
		tempNode.R[8] = temp2[8];

	}
}



void calculateFinalNode()
{
	for (int i = 0; i < 9; i++)
	{
		finalNode.B[i] = startNode.B[4];
		finalNode.R[i] = startNode.R[4];
		finalNode.F[i] = startNode.F[4];
		finalNode.L[i] = startNode.L[4];
		finalNode.U[i] = startNode.U[4];
		finalNode.D[i] = startNode.D[4];
	}
}

void findPositionNonCorner(int color1, int color2, int node)
{
	if (N[node].actualNode.L[1] == color1 && N[0].actualNode.U[3] == color2)
		position = 1;

	if (N[node].actualNode.L[3] == color1 && N[0].actualNode.B[5] == color2)
		position = 3;

	if (N[node].actualNode.L[5] == color1 && N[0].actualNode.F[3] == color2)
		position = 5;

	if (N[node].actualNode.L[7] == color1 && N[0].actualNode.D[3] == color2)
		position = 7;

	if (N[node].actualNode.F[1] == color1 && N[0].actualNode.U[7] == color2)
		position = 10;

	if (N[node].actualNode.F[3] == color1 && N[0].actualNode.L[5] == color2)
		position = 12;

	if (N[node].actualNode.F[5] == color1 && N[0].actualNode.R[3] == color2)
		position = 14;

	if (N[node].actualNode.F[7] == color1 && N[0].actualNode.D[1] == color2)
		position = 16;

	if (N[node].actualNode.R[1] == color1 && N[0].actualNode.U[5] == color2)
		position = 19;

	if (N[node].actualNode.R[3] == color1 && N[0].actualNode.F[5] == color2)
		position = 21;

	if (N[node].actualNode.R[5] == color1 && N[0].actualNode.B[3] == color2)
		position = 23;

	if (N[node].actualNode.R[7] == color1 && N[0].actualNode.D[5] == color2)
		position = 25;

	if (N[node].actualNode.B[1] == color1 && N[0].actualNode.U[1] == color2)
		position = 28;

	if (N[node].actualNode.B[3] == color1 && N[0].actualNode.R[5] == color2)
		position = 30;

	if (N[node].actualNode.B[5] == color1 && N[0].actualNode.L[3] == color2)
		position = 32;

	if (N[node].actualNode.B[7] == color1 && N[0].actualNode.D[7] == color2)
		position = 34;

	if (N[node].actualNode.U[1] == color1 && N[0].actualNode.B[1] == color2)
		position = 37;

	if (N[node].actualNode.U[3] == color1 && N[0].actualNode.L[1] == color2)
		position = 39;

	if (N[node].actualNode.U[5] == color1 && N[0].actualNode.R[1] == color2)
		position = 41;

	if (N[node].actualNode.U[7] == color1 && N[0].actualNode.F[1] == color2)
		position = 43;

	if (N[node].actualNode.D[1] == color1 && N[0].actualNode.F[7] == color2)
		position = 46;

	if (N[node].actualNode.D[3] == color1 && N[0].actualNode.L[7] == color2)
		position = 48;

	if (N[node].actualNode.D[5] == color1 && N[0].actualNode.R[7] == color2)
		position = 50;

	if (N[node].actualNode.D[7] == color1 && N[0].actualNode.B[7] == color2)
		position = 52;
}

void findPositionCorner(int color1, int color2, int color3, int node)
{
	if (N[node].actualNode.L[0] == color1 && N[node].actualNode.U[0] == color2 && N[node].actualNode.B[2] == color3)
		position = 0;
	if (N[node].actualNode.L[0] == color1 && N[node].actualNode.U[0] == color3 && N[node].actualNode.B[2] == color2)
		position = 0;

	if (N[node].actualNode.L[2] == color1 && N[node].actualNode.U[6] == color2 && N[node].actualNode.F[0] == color3)
		position = 2;
	if (N[node].actualNode.L[2] == color1 && N[node].actualNode.U[6] == color3 && N[node].actualNode.F[0] == color2)
		position = 2;

	if (N[node].actualNode.L[6] == color1 && N[node].actualNode.D[6] == color2 && N[node].actualNode.B[8] == color3)
		position = 6;
	if (N[node].actualNode.L[6] == color1 && N[node].actualNode.D[6] == color3 && N[node].actualNode.B[8] == color2)
		position = 6;

	if (N[node].actualNode.L[8] == color1 && N[node].actualNode.D[0] == color2 && N[node].actualNode.F[6] == color3)
		position = 8;
	if (N[node].actualNode.L[8] == color1 && N[node].actualNode.D[0] == color3 && N[node].actualNode.F[6] == color2)
		position = 8;

	if (N[node].actualNode.F[0] == color1 && N[node].actualNode.L[2] == color2 && N[node].actualNode.U[6] == color3)
		position = 9;
	if (N[node].actualNode.F[0] == color1 && N[node].actualNode.L[2] == color3 && N[node].actualNode.U[6] == color2)
		position = 9;

	if (N[node].actualNode.F[2] == color1 && N[node].actualNode.R[0] == color2 && N[node].actualNode.U[8] == color3)
		position = 11;
	if (N[node].actualNode.F[2] == color1 && N[node].actualNode.R[0] == color2 && N[node].actualNode.U[8] == color3)
		position = 11;

	if (N[node].actualNode.F[6] == color1 && N[node].actualNode.L[8] == color2 && N[node].actualNode.D[0] == color3)
		position = 15;
	if (N[node].actualNode.F[6] == color1 && N[node].actualNode.L[8] == color3 && N[node].actualNode.D[0] == color2)
		position = 15;

	if (N[node].actualNode.F[8] == color1 && N[node].actualNode.R[6] == color2 && N[node].actualNode.D[2] == color3)
		position = 17;
	if (N[node].actualNode.F[8] == color1 && N[node].actualNode.R[6] == color3 && N[node].actualNode.D[2] == color2)
		position = 17;

	if (N[node].actualNode.R[0] == color1 && N[node].actualNode.U[8] == color2 && N[node].actualNode.F[2] == color3)
		position = 18;
	if (N[node].actualNode.R[0] == color1 && N[node].actualNode.U[8] == color3 && N[node].actualNode.F[2] == color2)
		position = 18;

	if (N[node].actualNode.R[2] == color1 && N[node].actualNode.B[0] == color2 && N[node].actualNode.U[2] == color3)
		position = 20;
	if (N[node].actualNode.R[2] == color1 && N[node].actualNode.B[0] == color3 && N[node].actualNode.U[2] == color2)
		position = 20;

	if (N[node].actualNode.R[6] == color1 && N[node].actualNode.F[8] == color2 && N[node].actualNode.D[2] == color3)
		position = 24;
	if (N[node].actualNode.R[6] == color1 && N[node].actualNode.F[8] == color3 && N[node].actualNode.D[2] == color2)
		position = 24;

	if (N[node].actualNode.R[8] == color1 && N[node].actualNode.D[8] == color2 && N[node].actualNode.B[6] == color3)
		position = 26;
	if (N[node].actualNode.R[8] == color1 && N[node].actualNode.D[8] == color3 && N[node].actualNode.B[6] == color2)
		position = 26;

	if (N[node].actualNode.B[0] == color1 && N[node].actualNode.U[2] == color2 && N[node].actualNode.R[2] == color3)
		position = 27;
	if (N[node].actualNode.B[0] == color1 && N[node].actualNode.U[2] == color3 && N[node].actualNode.R[2] == color2)
		position = 27;

	if (N[node].actualNode.B[2] == color1 && N[node].actualNode.U[0] == color2 && N[node].actualNode.L[0] == color3)
		position = 29;
	if (N[node].actualNode.B[2] == color1 && N[node].actualNode.U[0] == color3 && N[node].actualNode.L[0] == color2)
		position = 29;

	if (N[node].actualNode.B[6] == color1 && N[node].actualNode.D[8] == color2 && N[node].actualNode.R[8] == color3)
		position = 33;
	if (N[node].actualNode.B[6] == color1 && N[node].actualNode.D[8] == color3 && N[node].actualNode.R[8] == color2)
		position = 33;

	if (N[node].actualNode.B[8] == color1 && N[node].actualNode.D[6] == color2 && N[node].actualNode.L[6] == color3)
		position = 35;
	if (N[node].actualNode.B[8] == color1 && N[node].actualNode.D[6] == color3 && N[node].actualNode.L[6] == color2)
		position = 35;

	if (N[node].actualNode.U[0] == color1 && N[node].actualNode.L[0] == color2 && N[node].actualNode.B[2] == color3)
		position = 36;
	if (N[node].actualNode.U[0] == color1 && N[node].actualNode.L[0] == color3 && N[node].actualNode.B[2] == color2)
		position = 36;

	if (N[node].actualNode.U[2] == color1 && N[node].actualNode.B[0] == color2 && N[node].actualNode.R[2] == color3)
		position = 38;
	if (N[node].actualNode.U[2] == color1 && N[node].actualNode.B[0] == color3 && N[node].actualNode.R[2] == color2)
		position = 38;

	if (N[node].actualNode.U[6] == color1 && N[node].actualNode.F[0] == color2 && N[node].actualNode.L[2] == color3)
		position = 42;
	if (N[node].actualNode.U[6] == color1 && N[node].actualNode.F[0] == color3 && N[node].actualNode.L[2] == color2)
		position = 42;

	if (N[node].actualNode.U[8] == color1 && N[node].actualNode.R[0] == color2 && N[node].actualNode.F[2] == color3)
		position = 44;
	if (N[node].actualNode.U[8] == color1 && N[node].actualNode.R[0] == color3 && N[node].actualNode.F[2] == color2)
		position = 44;

	if (N[node].actualNode.D[0] == color1 && N[node].actualNode.F[6] == color2 && N[node].actualNode.L[8] == color3)
		position = 45;
	if (N[node].actualNode.D[0] == color1 && N[node].actualNode.F[6] == color3 && N[node].actualNode.L[8] == color2)
		position = 45;

	if (N[node].actualNode.D[2] == color1 && N[node].actualNode.F[8] == color2 && N[node].actualNode.R[6] == color3)
		position = 47;
	if (N[node].actualNode.D[2] == color1 && N[node].actualNode.F[8] == color3 && N[node].actualNode.R[6] == color2)
		position = 47;

	if (N[node].actualNode.D[6] == color1 && N[node].actualNode.B[8] == color2 && N[node].actualNode.L[6] == color3)
		position = 51;
	if (N[node].actualNode.D[6] == color1 && N[node].actualNode.B[8] == color3 && N[node].actualNode.L[6] == color2)
		position = 51;

	if (N[node].actualNode.D[8] == color1 && N[node].actualNode.R[8] == color2 && N[node].actualNode.B[6] == color3)
		position = 53;
	if (N[node].actualNode.D[8] == color1 && N[node].actualNode.R[8] == color3 && N[node].actualNode.B[6] == color2)
		position = 53;

}


void cruxAlg(int a)
{
	if (a == 0)
	{
		N[0].path[N[0].nodes++] = tempSide[UP] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[UP] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[RIGHT] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[RIGHT] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[UP];
		tempNode = N[0].actualNode;
		move(tempSide[UP]);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[FRONT] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[FRONT] + 1);
		N[0].actualNode = tempNode;
	}
	if (a == 1)
	{
		N[0].path[N[0].nodes++] = tempSide[FRONT] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[FRONT] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[RIGHT] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[RIGHT] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[DOWN] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[DOWN] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[RIGHT];
		tempNode = N[0].actualNode;
		move(tempSide[RIGHT]);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[FRONT];
		tempNode = N[0].actualNode;
		move(tempSide[FRONT]);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[FRONT];
		tempNode = N[0].actualNode;
		move(tempSide[FRONT]);
		N[0].actualNode = tempNode;
	}
	if (a == 2)
	{
		N[0].path[N[0].nodes++] = tempSide[RIGHT] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[RIGHT] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[DOWN] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[DOWN] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[RIGHT];
		tempNode = N[0].actualNode;
		move(tempSide[RIGHT]);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[FRONT];
		tempNode = N[0].actualNode;
		move(tempSide[FRONT]);
		N[0].actualNode = tempNode;
	}

}

void checkSuperiorCrux()
{

	findPositionNonCorner(finalNode.U[4], finalNode.F[4], 0);
	while (position != 43)
	{

		findPositionNonCorner(finalNode.U[4], finalNode.F[4], 0);
		if (position == 1 || position == 12 || position == 7 || position == 48)
		{
			N[0].path[N[0].nodes++] = 1;
			tempNode = N[0].actualNode;
			move(1);
			N[0].actualNode = tempNode;
		}
		if (position == 3 || position == 28 || position == 34 || position == 52)
		{
			N[0].path[N[0].nodes++] = 3;
			tempNode = N[0].actualNode;
			move(3);
			N[0].actualNode = tempNode;
		}
		if (position == 5 || position == 10 || position == 16 || position == 46)
		{
			N[0].path[N[0].nodes++] = 6;
			tempNode = N[0].actualNode;
			move(6);
			N[0].actualNode = tempNode;
		}
		if (position == 14 || position == 19 || position == 25 || position == 50)
		{
			N[0].path[N[0].nodes++] = 4;
			tempNode = N[0].actualNode;
			move(4);
			N[0].actualNode = tempNode;
		}
		if (position == 21)
		{
			N[0].path[N[0].nodes++] = 7;
			tempNode = N[0].actualNode;
			move(7);
			N[0].actualNode = tempNode;
		}
		if (position == 23)
		{
			N[0].path[N[0].nodes++] = 2;
			tempNode = N[0].actualNode;
			move(2);
			N[0].actualNode = tempNode;
		}
		if (position == 30)
		{
			N[0].path[N[0].nodes++] = 5;
			tempNode = N[0].actualNode;
			move(5);
			N[0].actualNode = tempNode;
		}
		if (position == 32)
		{
			N[0].path[N[0].nodes++] = 0;
			tempNode = N[0].actualNode;
			move(0);
			N[0].actualNode = tempNode;
		}
		if (position == 37 || position == 39 || position == 41)
		{
			N[0].path[N[0].nodes++] = 8;
			tempNode = N[0].actualNode;
			move(8);
			N[0].actualNode = tempNode;
		}
	}
	findPositionNonCorner(finalNode.U[4], finalNode.L[4], 0);
	while (position != 39)
	{
		temporalFront(LEFT);
		findPositionNonCorner(finalNode.U[4], finalNode.L[4], 0);
		if (position == 1)
			cruxAlg(0);
		if (position == 7)
			cruxAlg(1);
		if (position == 5)
			cruxAlg(2);


		if (position == 12 || position == 48 || position == 3)
		{
			N[0].path[N[0].nodes++] = 1;
			tempNode = N[0].actualNode;
			move(1);
			N[0].actualNode = tempNode;
		}

		if (position == 23)
		{
			N[0].path[N[0].nodes++] = BACKCW + 1;
			tempNode = N[0].actualNode;
			move(BACKCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = BACKCW;
			tempNode = N[0].actualNode;
			move(BACKCW);
			N[0].actualNode = tempNode;
		}
		if (position == 46 || position == 50 || position == 25 || position == 52 || position == 16)
		{
			N[0].path[N[0].nodes++] = 10;
			tempNode = N[0].actualNode;
			move(10);
			N[0].actualNode = tempNode;
		}
		if (position == 32)
		{
			N[0].path[N[0].nodes++] = 0;
			tempNode = N[0].actualNode;
			move(0);
			N[0].actualNode = tempNode;
		}

		if (position == 28 || position == 30 || position == 34 || position == 37)
		{
			N[0].path[N[0].nodes++] = 2;
			tempNode = N[0].actualNode;
			move(2);
			N[0].actualNode = tempNode;
		}

		if (position == 14 || position == 19 || position == 21 || position == 41)
		{
			N[0].path[N[0].nodes++] = 5;
			tempNode = N[0].actualNode;
			move(5);
			N[0].actualNode = tempNode;
		}

	}

	findPositionNonCorner(finalNode.U[4], finalNode.R[4], 0);
	while (position != 41)
	{
		temporalFront(RIGHT);
		findPositionNonCorner(finalNode.U[4], finalNode.R[4], 0);
		if (position == 19)
			cruxAlg(0);
		if (position == 25)
			cruxAlg(1);
		if (position == 23)
			cruxAlg(2);


		if (position == 21 || position == 50 || position == 30)
		{
			N[0].path[N[0].nodes++] = RIGHTCW + 1;
			tempNode = N[0].actualNode;
			move(RIGHTCW + 1);
			N[0].actualNode = tempNode;
		}
		if (position == 14)
		{
			N[0].path[N[0].nodes++] = RIGHTCW;
			tempNode = N[0].actualNode;
			move(RIGHTCW);
			N[0].actualNode = tempNode;
		}
		if (position == 46 || position == 48 || position == 7 || position == 52 || position == 16 || position == 34)
		{
			N[0].path[N[0].nodes++] = 10;
			tempNode = N[0].actualNode;
			move(10);
			N[0].actualNode = tempNode;
		}
		if (position == 32)
		{
			N[0].path[N[0].nodes++] = UPCW + 1;
			tempNode = N[0].actualNode;
			move(UPCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = LEFTCW + 1;
			tempNode = N[0].actualNode;
			move(LEFTCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = UPCW;
			tempNode = N[0].actualNode;
			move(UPCW);
			N[0].actualNode = tempNode;
		}
		if (position == 3)
		{
			N[0].path[N[0].nodes++] = BACKCW;
			tempNode = N[0].actualNode;
			move(BACKCW);
			N[0].actualNode = tempNode;

		}
		if (position == 5 || position == 12)
		{
			N[0].path[N[0].nodes++] = UPCW + 1;
			tempNode = N[0].actualNode;
			move(UPCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = UPCW + 1;
			tempNode = N[0].actualNode;
			move(UPCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = LEFTCW;
			tempNode = N[0].actualNode;
			move(LEFTCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = UPCW;
			tempNode = N[0].actualNode;
			move(UPCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = UPCW;
			tempNode = N[0].actualNode;
			move(UPCW);
			N[0].actualNode = tempNode;
		}
		if (position == 28 || position == 30 || position == 32 || position == 37)
		{
			N[0].path[N[0].nodes++] = BACKCW;
			tempNode = N[0].actualNode;
			move(BACKCW);
			N[0].actualNode = tempNode;
		}


	}

	findPositionNonCorner(finalNode.U[4], finalNode.B[4], 0);
	while (position != 37)
	{
		temporalFront(BACK);
		findPositionNonCorner(finalNode.U[4], finalNode.B[4], 0);
		if (position == 28)
			cruxAlg(0);
		if (position == 34)
			cruxAlg(1);
		if (position == 32)
			cruxAlg(2);


		if (position == 21 || position == 14)
		{
			N[0].path[N[0].nodes++] = UPCW;
			tempNode = N[0].actualNode;
			move(UPCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = RIGHTCW + 1;
			tempNode = N[0].actualNode;
			move(RIGHTCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = UPCW + 1;
			tempNode = N[0].actualNode;
			move(UPCW + 1);
			N[0].actualNode = tempNode;
		}
		if (position == 46 || position == 48 || position == 7 || position == 50 || position == 16 || position == 25)
		{
			N[0].path[N[0].nodes++] = 10;
			tempNode = N[0].actualNode;
			move(10);
			N[0].actualNode = tempNode;
		}
		if (position == 3)
		{
			N[0].path[N[0].nodes++] = BACKCW + 1;
			tempNode = N[0].actualNode;
			move(BACKCW + 1);
			N[0].actualNode = tempNode;

		}
		if (position == 5 || position == 12)
		{
			N[0].path[N[0].nodes++] = UPCW + 1;
			tempNode = N[0].actualNode;
			move(UPCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = LEFTCW;
			tempNode = N[0].actualNode;
			move(LEFTCW);
			N[0].actualNode = tempNode;
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = UPCW;
			tempNode = N[0].actualNode;
			move(UPCW);
			N[0].actualNode = tempNode;
		}
		if (position == 30 || position == 52 || position == 23)
		{
			N[0].path[N[0].nodes++] = BACKCW;
			tempNode = N[0].actualNode;
			move(BACKCW);
			N[0].actualNode = tempNode;
		}


	}


}


void checkSuperiorCorner()
{

	findPositionCorner(finalNode.U[4], finalNode.F[4], finalNode.R[4], 0);
	while (position != 44)
	{

		findPositionCorner(finalNode.U[4], finalNode.F[4], finalNode.R[4], 0);
		if (position == 0 || position == 29 || position == 36)
		{
			N[0].path[N[0].nodes++] = (LEFTCW + 1);
			tempNode = N[0].actualNode;
			move(LEFTCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = (DOWNCW + 1);
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = (LEFTCW);
			tempNode = N[0].actualNode;
			move(LEFTCW);
			N[0].actualNode = tempNode;
		}
		if (position == 2 || position == 9 || position == 42)
		{
			N[0].path[N[0].nodes++] = (LEFTCW);
			tempNode = N[0].actualNode;
			move(LEFTCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = (DOWNCW);
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = (LEFTCW + 1);
			tempNode = N[0].actualNode;
			move(LEFTCW + 1);
			N[0].actualNode = tempNode;
		}
		if (position == 20 || position == 27 || position == 38)
		{
			N[0].path[N[0].nodes++] = (RIGHTCW);
			tempNode = N[0].actualNode;
			move(RIGHTCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = (DOWNCW);
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = (RIGHTCW + 1);
			tempNode = N[0].actualNode;
			move(RIGHTCW + 1);
			N[0].actualNode = tempNode;
		}
		if (position == 6 || position == 8 || position == 15 || position == 26 || position == 33 || position == 35 || position == 45 || position == 51 || position == 53)
		{
			N[0].path[N[0].nodes++] = DOWNCW;
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;
		}
		if (position == 11 || position == 18)
		{
			N[0].path[N[0].nodes++] = RIGHTCW + 1;
			tempNode = N[0].actualNode;
			move(RIGHTCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = RIGHTCW;
			tempNode = N[0].actualNode;
			move(RIGHTCW);
			N[0].actualNode = tempNode;
		}
		if (position == 17 || position == 47)
		{
			N[0].path[N[0].nodes++] = RIGHTCW + 1;
			tempNode = N[0].actualNode;
			move(RIGHTCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = RIGHTCW;
			tempNode = N[0].actualNode;
			move(RIGHTCW);
			N[0].actualNode = tempNode;


		}
		if (position == 24)
		{
			N[0].path[N[0].nodes++] = RIGHTCW + 1;
			tempNode = N[0].actualNode;
			move(RIGHTCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = RIGHTCW;
			tempNode = N[0].actualNode;
			move(RIGHTCW);
			N[0].actualNode = tempNode;


		}


	}


	findPositionCorner(finalNode.U[4], finalNode.R[4], finalNode.B[4], 0);
	while (position != 38)
	{

		findPositionCorner(finalNode.U[4], finalNode.R[4], finalNode.B[4], 0);
		if (position == 0 || position == 29 || position == 36)
		{
			N[0].path[N[0].nodes++] = (LEFTCW + 1);
			tempNode = N[0].actualNode;
			move(LEFTCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = (DOWNCW + 1);
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = (LEFTCW);
			tempNode = N[0].actualNode;
			move(LEFTCW);
			N[0].actualNode = tempNode;
		}
		if (position == 2 || position == 9 || position == 42)
		{
			N[0].path[N[0].nodes++] = (LEFTCW);
			tempNode = N[0].actualNode;
			move(LEFTCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = (DOWNCW);
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = (LEFTCW + 1);
			tempNode = N[0].actualNode;
			move(LEFTCW + 1);
			N[0].actualNode = tempNode;
		}
		if (position == 6 || position == 8 || position == 15 || position == 17 || position == 24 || position == 35 || position == 45 || position == 51 || position == 47)
		{
			N[0].path[N[0].nodes++] = DOWNCW;
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;
		}
		if (position == 26)
		{

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = BACKCW + 1;
			tempNode = N[0].actualNode;
			move(BACKCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW;
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = BACKCW;
			tempNode = N[0].actualNode;
			move(BACKCW);
			N[0].actualNode = tempNode;


		}
		if (position == 53)
		{

			N[0].path[N[0].nodes++] = BACKCW + 1;
			tempNode = N[0].actualNode;
			move(BACKCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = BACKCW;
			tempNode = N[0].actualNode;
			move(BACKCW);
			N[0].actualNode = tempNode;


		}
		if (position == 33 || position == 20 || position == 27)
		{
			N[0].path[N[0].nodes++] = BACKCW + 1;
			tempNode = N[0].actualNode;
			move(BACKCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = BACKCW;
			tempNode = N[0].actualNode;
			move(BACKCW);
			N[0].actualNode = tempNode;


		}

	}

	findPositionCorner(finalNode.U[4], finalNode.B[4], finalNode.L[4], 0);
	while (position != 36)
	{

		findPositionCorner(finalNode.U[4], finalNode.B[4], finalNode.L[4], 0);
		if (position == 2 || position == 9 || position == 42)
		{
			N[0].path[N[0].nodes++] = (LEFTCW);
			tempNode = N[0].actualNode;
			move(LEFTCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = (DOWNCW);
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = (LEFTCW + 1);
			tempNode = N[0].actualNode;
			move(LEFTCW + 1);
			N[0].actualNode = tempNode;
		}
		if (position == 8 || position == 15 || position == 17 || position == 24 || position == 26 || position == 33 || position == 45 || position == 47 || position == 53)
		{
			N[0].path[N[0].nodes++] = DOWNCW;
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;
		}
		if (position == 35)
		{
			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = LEFTCW + 1;
			tempNode = N[0].actualNode;
			move(LEFTCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW;
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = LEFTCW;
			tempNode = N[0].actualNode;
			move(LEFTCW);
			N[0].actualNode = tempNode;


		}
		if (position == 51)
		{
			N[0].path[N[0].nodes++] = LEFTCW + 1;
			tempNode = N[0].actualNode;
			move(LEFTCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = LEFTCW;
			tempNode = N[0].actualNode;
			move(LEFTCW);
			N[0].actualNode = tempNode;


		}
		if (position == 6 || position == 0 || position == 29)
		{
			N[0].path[N[0].nodes++] = LEFTCW + 1;
			tempNode = N[0].actualNode;
			move(LEFTCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = LEFTCW;
			tempNode = N[0].actualNode;
			move(LEFTCW);
			N[0].actualNode = tempNode;


		}

	}

	findPositionCorner(finalNode.U[4], finalNode.L[4], finalNode.F[4], 0);
	while (position != 42)
	{

		findPositionCorner(finalNode.U[4], finalNode.L[4], finalNode.F[4], 0);
		if (position == 6 || position == 17 || position == 24 || position == 26 || position == 33 || position == 35 || position == 51 || position == 47 || position == 53)
		{
			N[0].path[N[0].nodes++] = DOWNCW;
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;
		}

		if (position == 8)
		{
			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = FRONTCW + 1;
			tempNode = N[0].actualNode;
			move(FRONTCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW;
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = FRONTCW;
			tempNode = N[0].actualNode;
			move(FRONTCW);
			N[0].actualNode = tempNode;


		}
		if (position == 45)
		{
			N[0].path[N[0].nodes++] = FRONTCW + 1;
			tempNode = N[0].actualNode;
			move(FRONTCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = FRONTCW;
			tempNode = N[0].actualNode;
			move(FRONTCW);
			N[0].actualNode = tempNode;


		}
		if (position == 15 || position == 9 || position == 2)
		{
			N[0].path[N[0].nodes++] = FRONTCW + 1;
			tempNode = N[0].actualNode;
			move(FRONTCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;

			N[0].path[N[0].nodes++] = FRONTCW;
			tempNode = N[0].actualNode;
			move(FRONTCW);
			N[0].actualNode = tempNode;


		}

	}



}


void middleAlg(int a)
{
	if (a == 0)
	{
		N[0].path[N[0].nodes++] = tempSide[DOWN] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[DOWN] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[RIGHT] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[RIGHT] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[DOWN];
		tempNode = N[0].actualNode;
		move(tempSide[DOWN]);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[RIGHT];
		tempNode = N[0].actualNode;
		move(tempSide[RIGHT]);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[DOWN];
		tempNode = N[0].actualNode;
		move(tempSide[DOWN]);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[FRONT];
		tempNode = N[0].actualNode;
		move(tempSide[FRONT]);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[DOWN] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[DOWN] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[FRONT] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[FRONT] + 1);
		N[0].actualNode = tempNode;
	}
	if (a == 1)
	{
		N[0].path[N[0].nodes++] = tempSide[DOWN];
		tempNode = N[0].actualNode;
		move(tempSide[DOWN]);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[LEFT];
		tempNode = N[0].actualNode;
		move(tempSide[LEFT]);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[DOWN] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[DOWN] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[LEFT] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[LEFT] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[DOWN] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[DOWN] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[FRONT] + 1;
		tempNode = N[0].actualNode;
		move(tempSide[FRONT] + 1);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[DOWN];
		tempNode = N[0].actualNode;
		move(tempSide[DOWN]);
		N[0].actualNode = tempNode;

		N[0].path[N[0].nodes++] = tempSide[FRONT];
		tempNode = N[0].actualNode;
		move(tempSide[FRONT]);
		N[0].actualNode = tempNode;
	}

}
void checkMiddle()
{
	findPositionNonCorner(finalNode.F[4], finalNode.L[4], 0);
	while (position != 12)
	{
		findPositionNonCorner(finalNode.F[4], finalNode.L[4], 0);

		if (position == 16 || position == 5)
		{
			temporalFront(FRONT);
			middleAlg(1);
		}
		if (position == 48)
		{
			temporalFront(LEFT);
			middleAlg(0);
		}
		if (position == 7 || position == 46 || position == 25 || position == 50 || position == 34 || position == 52)
		{
			N[0].path[N[0].nodes++] = DOWNCW;
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;
		}

		if (position == 3 || position == 32)
		{
			temporalFront(LEFT);
			middleAlg(1);
		}
		if (position == 14 || position == 21)
		{
			temporalFront(FRONT);
			middleAlg(0);
		}
		if (position == 30 || position == 23)
		{
			temporalFront(RIGHT);
			middleAlg(0);
		}

	}

	findPositionNonCorner(finalNode.R[4], finalNode.F[4], 0);
	while (position != 21)
	{
		findPositionNonCorner(finalNode.R[4], finalNode.F[4], 0);

		if (position == 25 || position == 14)
		{
			temporalFront(RIGHT);
			middleAlg(1);
		}
		if (position == 46)
		{
			temporalFront(FRONT);
			middleAlg(0);
		}
		if (position == 7 || position == 48 || position == 16 || position == 50 || position == 34 || position == 52)
		{
			N[0].path[N[0].nodes++] = DOWNCW;
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;
		}

		if (position == 3 || position == 32)
		{
			temporalFront(LEFT);
			middleAlg(1);
		}
		if (position == 30 || position == 23)
		{
			temporalFront(RIGHT);
			middleAlg(0);
		}

	}

	findPositionNonCorner(finalNode.B[4], finalNode.R[4], 0);
	while (position != 30)
	{
		findPositionNonCorner(finalNode.B[4], finalNode.R[4], 0);

		if (position == 34 || position == 23)
		{
			temporalFront(BACK);
			middleAlg(1);
		}
		if (position == 50)
		{
			temporalFront(RIGHT);
			middleAlg(0);
		}
		if (position == 7 || position == 48 || position == 16 || position == 46 || position == 25 || position == 52)
		{
			N[0].path[N[0].nodes++] = DOWNCW;
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;
		}

		if (position == 3 || position == 32)
		{
			temporalFront(LEFT);
			middleAlg(1);
		}


	}

	findPositionNonCorner(finalNode.L[4], finalNode.B[4], 0);
	while (position != 3)
	{
		findPositionNonCorner(finalNode.L[4], finalNode.B[4], 0);

		if (position == 32 || position == 7)
		{
			temporalFront(LEFT);
			middleAlg(1);
		}
		if (position == 52)
		{
			temporalFront(BACK);
			middleAlg(0);
		}
		if (position == 48 || position == 16 || position == 46 || position == 25 || position == 50 || position == 34)
		{
			N[0].path[N[0].nodes++] = DOWNCW;
			tempNode = N[0].actualNode;
			move(DOWNCW);
			N[0].actualNode = tempNode;
		}



	}


}

void inferiorCruxAlg()
{
	N[0].path[N[0].nodes++] = tempSide[FRONT];
	tempNode = N[0].actualNode;
	move(tempSide[FRONT]);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[LEFT];
	tempNode = N[0].actualNode;
	move(tempSide[LEFT]);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[DOWN];
	tempNode = N[0].actualNode;
	move(tempSide[DOWN]);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[LEFT] + 1;
	tempNode = N[0].actualNode;
	move(tempSide[LEFT] + 1);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[DOWN] + 1;
	tempNode = N[0].actualNode;
	move(tempSide[DOWN] + 1);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[FRONT] + 1;
	tempNode = N[0].actualNode;
	move(tempSide[FRONT] + 1);
	N[0].actualNode = tempNode;


}
void orderInferiorCruxAlg()
{
	N[0].path[N[0].nodes++] = tempSide[LEFT];
	tempNode = N[0].actualNode;
	move(tempSide[LEFT]);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[DOWN];
	tempNode = N[0].actualNode;
	move(tempSide[DOWN]);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[LEFT] + 1;
	tempNode = N[0].actualNode;
	move(tempSide[LEFT] + 1);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[DOWN];
	tempNode = N[0].actualNode;
	move(tempSide[DOWN]);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[LEFT];
	tempNode = N[0].actualNode;
	move(tempSide[LEFT]);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[DOWN];
	tempNode = N[0].actualNode;
	move(tempSide[DOWN]);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[DOWN];
	tempNode = N[0].actualNode;
	move(tempSide[DOWN]);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[LEFT] + 1;
	tempNode = N[0].actualNode;
	move(tempSide[LEFT] + 1);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[DOWN];
	tempNode = N[0].actualNode;
	move(tempSide[DOWN]);
	N[0].actualNode = tempNode;


}
void checkInferiorCrux()
{
	while (N[0].actualNode.D[3] != finalNode.D[4] || N[0].actualNode.D[5] != finalNode.D[4] || N[0].actualNode.D[1] != finalNode.D[4] || N[0].actualNode.D[7] != finalNode.D[4])
	{

		if (N[0].actualNode.D[3] == finalNode.D[4] && N[0].actualNode.D[5] == finalNode.D[4] && N[0].actualNode.D[1] != finalNode.D[4] && N[0].actualNode.D[7] != finalNode.D[4])
		{
			temporalFront(FRONT);
			inferiorCruxAlg();
		}
		else if (N[0].actualNode.D[1] == finalNode.D[4] && N[0].actualNode.D[7] == finalNode.D[4] && N[0].actualNode.D[3] != finalNode.D[4] && N[0].actualNode.D[5] != finalNode.D[4])
		{
			temporalFront(LEFT);
			inferiorCruxAlg();
		}
		else if (N[0].actualNode.D[1] == finalNode.D[4] && N[0].actualNode.D[3] == finalNode.D[4] && N[0].actualNode.D[5] != finalNode.D[4] && N[0].actualNode.D[7] != finalNode.D[4])
		{
			temporalFront(BACK);
			inferiorCruxAlg();
			inferiorCruxAlg();
		}
		else if (N[0].actualNode.D[1] == finalNode.D[4] && N[0].actualNode.D[5] == finalNode.D[4] && N[0].actualNode.D[3] != finalNode.D[4] && N[0].actualNode.D[7] != finalNode.D[4])
		{
			temporalFront(LEFT);
			inferiorCruxAlg();
			inferiorCruxAlg();
		}
		else if (N[0].actualNode.D[5] == finalNode.D[4] && N[0].actualNode.D[7] == finalNode.D[4] && N[0].actualNode.D[1] != finalNode.D[4] && N[0].actualNode.D[3] != finalNode.D[4])
		{
			temporalFront(FRONT);
			inferiorCruxAlg();
			inferiorCruxAlg();
		}
		else if (N[0].actualNode.D[3] == finalNode.D[4] && N[0].actualNode.D[7] == finalNode.D[4] && N[0].actualNode.D[1] != finalNode.D[4] && N[0].actualNode.D[5] != finalNode.D[4])
		{
			temporalFront(RIGHT);
			inferiorCruxAlg();
			inferiorCruxAlg();
		}
		else if (N[0].actualNode.D[1] != finalNode.D[4] && N[0].actualNode.D[3] != finalNode.D[4] && N[0].actualNode.D[5] != finalNode.D[4] && N[0].actualNode.D[7] != finalNode.D[4])
		{
			temporalFront(FRONT);
			inferiorCruxAlg();
		}
	}
	findPositionNonCorner(finalNode.F[4], finalNode.D[4], 0);
	while (position != 16)
	{
		findPositionNonCorner(finalNode.F[4], finalNode.D[4], 0);

		if (position != 16)
		{
			N[0].path[N[0].nodes++] = DOWNCW + 1;
			tempNode = N[0].actualNode;
			move(DOWNCW + 1);
			N[0].actualNode = tempNode;
		}
	}


	findPositionNonCorner(finalNode.R[4], finalNode.D[4], 0);
	while (position != 25)
	{
		findPositionNonCorner(finalNode.R[4], finalNode.D[4], 0);
		if (position == 34)
		{
			temporalFront(RIGHT);
			orderInferiorCruxAlg();
		}
		if (position == 7)
		{
			temporalFront(BACK);
			orderInferiorCruxAlg();
		}

	}

	findPositionNonCorner(finalNode.B[4], finalNode.D[4], 0);
	if (position != 34)
	{

		temporalFront(BACK);
		orderInferiorCruxAlg();
	}

}
int findCorner()
{
	int t = 10;
	if (position == 6 || position == 35 || position == 51)
		t = 0;
	if (position == 8 || position == 15 || position == 45)
		t = 1;
	if (position == 17 || position == 24 || position == 47)
		t = 2;
	if (position == 26 || position == 33 || position == 53)
		t = 3;

	return t;

}


void inferiorCornerAlg()
{
	N[0].path[N[0].nodes++] = tempSide[DOWN];
	tempNode = N[0].actualNode;
	move(tempSide[DOWN]);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[LEFT];
	tempNode = N[0].actualNode;
	move(tempSide[LEFT]);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[DOWN] + 1;
	tempNode = N[0].actualNode;
	move(tempSide[DOWN] + 1);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[RIGHT] + 1;
	tempNode = N[0].actualNode;
	move(tempSide[RIGHT] + 1);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[DOWN];
	tempNode = N[0].actualNode;
	move(tempSide[DOWN]);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[LEFT] + 1;
	tempNode = N[0].actualNode;
	move(tempSide[LEFT] + 1);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[DOWN] + 1;
	tempNode = N[0].actualNode;
	move(tempSide[DOWN] + 1);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[RIGHT];
	tempNode = N[0].actualNode;
	move(tempSide[RIGHT]);
	N[0].actualNode = tempNode;

}
void checkInferiorCorner()
{
	int corner[4];
	int fixedCorner = 10;
	int tempEnd = NO;
	while (tempEnd == NO)
	{
		findPositionCorner(finalNode.D[4], finalNode.L[4], finalNode.B[4], 0);
		corner[0] = findCorner();

		findPositionCorner(finalNode.D[4], finalNode.F[4], finalNode.L[4], 0);
		corner[1] = findCorner();

		findPositionCorner(finalNode.D[4], finalNode.R[4], finalNode.F[4], 0);
		corner[2] = findCorner();

		findPositionCorner(finalNode.D[4], finalNode.R[4], finalNode.B[4], 0);
		corner[3] = findCorner();

		for (int i = 0; i < 4; i++)
		{
			if (corner[i] == i)
				fixedCorner = i;
		}
		if (corner[0] == 0 && corner[1] == 1 && corner[2] == 2 && corner[3] == 3)
		{
			tempEnd = YES;
		}
		else if (fixedCorner > 3 || fixedCorner == 1)
		{
			temporalFront(FRONT);
			inferiorCornerAlg();
		}
		else if (fixedCorner == 0)
		{
			temporalFront(LEFT);
			inferiorCornerAlg();
		}
		else if (fixedCorner == 2)
		{
			temporalFront(RIGHT);
			inferiorCornerAlg();
		}
		else if (fixedCorner == 3)
		{
			temporalFront(BACK);
			inferiorCornerAlg();
		}
	}




}

void lastAlg()
{
	N[0].path[N[0].nodes++] = tempSide[LEFT] + 1;
	tempNode = N[0].actualNode;
	move(tempSide[LEFT] + 1);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[UP] + 1;
	tempNode = N[0].actualNode;
	move(tempSide[UP] + 1);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[LEFT];
	tempNode = N[0].actualNode;
	move(tempSide[LEFT]);
	N[0].actualNode = tempNode;

	N[0].path[N[0].nodes++] = tempSide[UP];
	tempNode = N[0].actualNode;
	move(tempSide[UP]);
	N[0].actualNode = tempNode;

}

void checkLast()
{
	findPositionCorner(finalNode.D[4], finalNode.F[4], finalNode.L[4], 0);
	while (position != 45)
	{
		findPositionCorner(finalNode.D[4], finalNode.F[4], finalNode.L[4], 0);
		if (position != 45)
		{
			temporalFront(FRONT);
			lastAlg();
		}

	}
	N[0].path[N[0].nodes++] = DOWNCW + 1;
	tempNode = N[0].actualNode;
	move(DOWNCW + 1);
	N[0].actualNode = tempNode;

	findPositionCorner(finalNode.D[4], finalNode.F[4], finalNode.R[4], 0);
	while (position != 45)
	{
		findPositionCorner(finalNode.D[4], finalNode.F[4], finalNode.R[4], 0);
		if (position != 45)
		{
			temporalFront(FRONT);
			lastAlg();
		}

	}

	N[0].path[N[0].nodes++] = DOWNCW + 1;
	tempNode = N[0].actualNode;
	move(DOWNCW + 1);
	N[0].actualNode = tempNode;

	findPositionCorner(finalNode.D[4], finalNode.R[4], finalNode.B[4], 0);
	while (position != 45)
	{
		findPositionCorner(finalNode.D[4], finalNode.R[4], finalNode.B[4], 0);
		if (position != 45)
		{
			temporalFront(FRONT);
			lastAlg();
		}

	}

	N[0].path[N[0].nodes++] = DOWNCW + 1;
	tempNode = N[0].actualNode;
	move(DOWNCW + 1);
	N[0].actualNode = tempNode;

	findPositionCorner(finalNode.D[4], finalNode.B[4], finalNode.L[4], 0);
	while (position != 45)
	{
		findPositionCorner(finalNode.D[4], finalNode.B[4], finalNode.L[4], 0);
		if (position != 45)
		{
			temporalFront(FRONT);
			lastAlg();
		}

	}

	N[0].path[N[0].nodes++] = DOWNCW + 1;
	tempNode = N[0].actualNode;
	move(DOWNCW + 1);
	N[0].actualNode = tempNode;

	findPositionNonCorner(finalNode.U[4], finalNode.F[4], 0);
	while (position != 43)
	{
		findPositionNonCorner(finalNode.U[4], finalNode.F[4], 0);
		if (position != 43)
		{
			N[0].path[N[0].nodes++] = UPCW + 1;
			tempNode = N[0].actualNode;
			move(UPCW + 1);
			N[0].actualNode = tempNode;
		}

	}

}
